uses dos,crt,ddplusa,filelock;

type player_info = record
   name: string[20]; {player handle in the game}
   real_name: string[50] {real name/or handle from BBS} ;
   hit_points  {player hit points}
  ,bad  {don't know - might not be used at all}
  ,rate: integer; {again, couldn't find this one in the source}
  hit_max: integer; {hit_point max}
  weapon_num: integer; {weapon number}
  weapon: string[20]; {name of weapon}
  seen_master: integer; {equals 5 if seen master, else 0}
  fights_left: integer; {forest fights left}
  human_left: integer; {human fights left}
  gold: longint; {gold in hand}
  bank: longint; {gold in bank}
  def: integer;  {total defense points }
  strength: integer; {total strength}
  charm: integer; {good looking meter}
  seen_dragon: integer; {seen dragon?  5 if yes else 0}
  seen_violet: integer; {seen violet?  5 if yes else 0}
  level: integer; {level of player}
  time: word; {day # that player last played on}
  arm: string[20]; {armour name}
  arm_num: integer; {armour number}
  dead: shortint; {player dead?  5 if yes else 0}
  inn: shortint; {player sleeping at inn?  5 if yes else 0}
  gem: integer; {# of gems on hand}
  exp: longint; {experience}
  sex: shortint; {gender, 5 if female else 0}
  seen_bard: shortint; {seen bard?  5 if yes else 0}
  last_alive_time: integer; {day # player was last reincarnated on}
  Lays: integer; {players lays stat}
  Why: integer; {not used yet}
  on_now: boolean; {is player on?}
  m_time: integer; {day on_now stat was last used}
  time_on: string[5]; {time player logged on in Hour:Minutes format}
  class: shortint; {class, should be 1, 2 or 3}
  extra: integer;      {*NEW*  If 1, player has a horse}
  love: string[25]; {not used - may be used for inter-player marrages later}
  married: integer; {who player is married to, should be -1 if not married}
  kids: integer; {# of kids}
  king: integer; {# of times player has won game}
  skillw: shortint; {number of Death Knight skill points}
  skillm: shortint; {number of Mystical Skills points}
  skillt: shortint; {number of Thieving Skills points}

  levelw: shortint; {number of Death Knight skill uses left today}
  levelm: shortint; {number of Mystical skill uses left today}
  levelt: shortint; {number of Thieving skill uses left today}

  inn_random: boolean; {not used yet}
  married_to: integer; {same as Married, I think - don't know why it's here}
  v1: longint;
  v2: integer; {# of player kills}
  v3: integer; {if 5, 'wierd' event in forest will happen}
  v4: boolean; {has player done 'special' for that day?}
  v5: shortint; {has player flirted with another player that day?  if so, 5}
  new_stat1: shortint;
  new_stat2: shortint;  {these 3 are unused right now}
  new_stat3: shortint;  {Warning: Joseph's NPCLORD screws with all three}
end;

todaytype = array[0..149] of boolean;


var pf: file of player_info;
    pr: player_info;
    tr:todaytype;
    errcode:integer;
    saveexit:pointer;
    mynum:byte;
    openattempts : integer;
    elbow:array[1..14] of string[30];
    tempnum:byte;
    tempstr,slpath:string;
    data:text;


function fileexists(FNAME:string):boolean;
  var tfile:text;
      s: string;
  begin
    s := FSEARCH(FNAME,'');
    fileexists := s <> '';
  end;



procedure fwriteln(s:string);
 label DEVIL;
 var f,g,h: string;
     done:boolean;
     q:byte;
  begin
    done := false;
   repeat
    IF pos('`',s) > 0 then begin { IN ['0','1','2','3','4','5','6','7','8','9','!','@','#','$','%'] then begin}
       g := '';
       for q := 1 to POS('`',s)-1 do g := g + s[q];
       swrite(g);
       CASE s[POS('`',s)+1] of
       '1':set_foreground(1);
       '2':set_foreground(2);
       '3':set_foreground(3);
       '4':set_foreground(4);
       '5':set_foreground(5);
       '6':set_foreground(6);
       '7':set_foreground(7);
       '8':set_foreground(8);
       '9':set_foreground(9);
       '0':set_foreground(10);
       '!':set_foreground(11);
       '@':set_foreground(12);
       '#':set_foreground(13);
       '$':set_foreground(14);
       '%':set_foreground(15);
       end;
       f := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       s := f;
       end;
   until POS('`',s) = 0;
   swriteln(s);
  end;


procedure fwrite(s:string);
 label DEVIL;
 var f,g,h: string;
     done:boolean;
     q:byte;
  begin
    done := false;
    IF NOT POS('`',s) > 0 then begin
      swrite(s);
      exit;
    end;
   repeat
    IF pos('`',s)>0 then begin{IN ['0','1','2','3','4','5','6','7','8','9','!','@','#','$','%'] then begin}
       g := '';
       for q := 1 to POS('`',s)-1 do g := g + s[q];
       swrite(g);
       CASE s[POS('`',s)+1] of
       '1':set_foreground(1);
       '2':set_foreground(2);
       '3':set_foreground(3);
       '4':set_foreground(4);
       '5':set_foreground(5);
       '6':set_foreground(6);
       '7':set_foreground(7);
       '8':set_foreground(8);
       '9':set_foreground(9);
       '0':set_foreground(10);
       '!':set_foreground(11);
       '@':set_foreground(12);
       '#':set_foreground(13);
       '$':set_foreground(14);
       '%':set_foreground(15);
       end;
       f := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       s := f;
       end;
   until POS('`',s) = 0;
   swrite(s);
  end;


function stripped(s:string):string;
  var ti:byte;
  f,g:string;
  begin
    WHILE POS('`',s) > 0 do begin
      f := '';
      g := '';
      for ti := 1 to POS('`',s)-1 do f := f+s[ti];
      for ti := POS('`',s)+2 to length(s) do g := g + s[ti];
      s := f+g;
    end;
    stripped :=s;
  end;


procedure lwriteln(s:string);
 label DEVIL;
 var f,g,h: string;
     done:boolean;
     q:byte;
  begin
    done := false;
    IF NOT POS('`',s) > 0 then begin
      writeln(s);
      exit;
    end;
   repeat
    IF s[pos('`',s)+1] IN ['0','1','2','3','4','5','6','7','8','9','!','@','#','$','%'] then begin
       g := '';
       for q := 1 to POS('`',s)-1 do g := g + s[q];
       write(g);
       CASE s[POS('`',s)+1] of
       '1':textcolor(1);
       '2':textcolor(2);
       '3':textcolor(3);
       '4':textcolor(4);
       '5':textcolor(5);
       '6':textcolor(6);
       '7':textcolor(7);
       '8':textcolor(8);
       '9':textcolor(9);
       '0':textcolor(10);
       '!':textcolor(11);
       '@':textcolor(12);
       '#':textcolor(13);
       '$':textcolor(14);
       '%':textcolor(15);
       end;
       f := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       s := f;
       end;
   until POS('`',s) = 0;
   writeln(s);
  end;
function caps(s:string):string;
 var c:byte;
  begin
    for c := 1 to length(s) do s[c] := UPCASE(s[c]);
    caps := s;
  end;

procedure lwrite(s:string);
 label DEVIL;
 var f,g,h: string;
     done:boolean;
     q:byte;
  begin
    done := false;
    IF NOT POS('`',s) > 0 then begin
      writeln(s);
      exit;
    end;
   repeat
    IF s[pos('`',s)+1] IN ['0','1','2','3','4','5','6','7','8','9','!','@','#','$','%'] then begin
       g := '';
       for q := 1 to POS('`',s)-1 do g := g + s[q];
       write(g);
       CASE s[POS('`',s)+1] of
       '1':textcolor(1);
       '2':textcolor(2);
       '3':textcolor(3);
       '4':textcolor(4);
       '5':textcolor(5);
       '6':textcolor(6);
       '7':textcolor(7);
       '8':textcolor(8);
       '9':textcolor(9);
       '0':textcolor(10);
       '!':textcolor(11);
       '@':textcolor(12);
       '#':textcolor(13);
       '$':textcolor(14);
       '%':textcolor(15);
       end;
       f := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       s := f;
       end;
   until POS('`',s) = 0;
   write(s);
  end;


procedure readin;
var tf:file of todaytype;
begin
  val(elbow[1],mynum,errcode);
  get_access_hard('player.dat',true);
    assign(pf,'player.dat');
    openattempts := 0;
    repeat
       inc(openattempts);
        {$I-}
        reset(pf);
       {$I+}
     until (openattempts >=1000) or (IOResult = 0);
    seek(pf,mynum);
    read(pf,pr);
    close(pf);
    unlock_file('player.dat');
    get_access_hard('slotto.dat',true);
    assign(tf,'slotto.dat');
    openattempts := 0;
    repeat
       inc(openattempts);
        {$I-}
        reset(tf);
       {$I+}
     until (openattempts >=1000) or (IOResult = 0);
    read(tf,tr);
    close(tf);
end;




procedure uninstallnet;
  var data,data2:text;
    t: array[1..30] of string;
    tempst:string;
    r: byte;
    s,f: byte;
  begin
    assign(data,tempstr+'3rdparty.dat');
    reset(data);
    s:=0;r:=0;f:=0;
    repeat
      inc(f);
      readln(data,t[f]);
      IF POS('slotto',t[f]) > 0 then s := f;
    until eof(data);
    close(data);
    IF s = 0 then begin
      writeln('slotto has not been installed yet!');
      halt;
    end;
    assign(data,tempstr+'3rdparty.dat');
    rewrite(data);
    for r := 1 to f do begin
      IF NOT (r = s) and not (r = s+1) then writeln(data,t[r]);
    end;
    close(data);
    lwriteln('`%Uninstalled!');
    lwriteln('`2<`0MORE`2>');
    readkey;
  end;



function installnet:boolean;
 var data,data2:text;
     t:array[1..30] of string;
     r,s,e:byte;
     tempst : string;
  begin
    r := 0;
    s := 0;
{    assign(data,tempstr+'3rdparty.dat');
    reset(data);
    repeat
      inc(s);
      readln(data,t[s]);
      IF POS('slotto',t[s]) > 0 then begin
        installnet := true;
        close(data);
        exit;
      end;
      IF NOT (t[s][1] = ';') then inc(r);
    until eof(data);
    close(data);}
{    IF (R > 16) then begin
      clrscr;
      writeln('You currently have too many Lord Utils installed!');
      writeln;
      writeln('Please remove one (from the 3RDPARTY.DAT file in the LORD directory).');
      halt(0);
    end;}
    assign(data,tempstr+'3rdparty.dat');
    tempst := '';
    {hymn := paramstr(0);
    for e := 1 to length(hymn)-11 do tempst := tempst + hymn[e];}
    append(data);
    writeln(data,slpath+'\slotto *');
    writeln(data,'`0Seth''s Tribute Lotto');
    close(data);


    writeln;
    lwriteln('`%Installed!');
    writeln;
    lwriteln('`2<`0MORE`2>');
    assign(data,slpath+'\slotto.cfg');
    rewrite(data);
    writeln(data,tempstr);
    close(data);
    readkey;
  end;



procedure configuration;
  label hiya;
  var ch:char;
  begin
    clrscr;
    lwriteln('                    `%Seth''s Lotto Setup!');
    writeln;
    tempstr := '';
    IF FILEEXISTS(slpath+'\slotto.cfg') then begin
       assign(data,slpath+'\slotto.cfg');
       reset(data);
       readln(data,tempstr);
       close(data);
    end;
    hiya:
    IF (TEMPSTR = '') then begin;
    writeln;
    lwrite('  `2Please enter your LORD path `0(`$C:\LORD\`0)`!:`% ');
    readln(tempstr);
    writeln;
    lwrite('`2Path is...');
    IF (tempstr[length(tempstr)] <> '\') then tempstr := tempstr + '\';
    IF fileexists(tempstr+'3rdparty.dat')
    then lwriteln('`0VERIFIED!') else begin
      lwriteln('`4INVALID');
      goto hiya;
    end;
    end;
    IF NOT FILEEXISTS(slpath+'\slotto.cfg') then begin
      assign(data,slpath+'\slotto.cfg');
      rewrite(data);
      writeln(data,tempstr);
      close(data);
    end;
    IF (installnet) then begin
      repeat
        clrscr;
        lwriteln('`0(`2U`0)`2ninstall Seth''s Lotto');
        lwriteln('`0(`2Q`0)`2uit CONFIG');
        ch := readkey;
        IF (UPCASE(CH) = 'Q') then halt(0);
        IF (UPCASE(CH) = 'U') then uninstallnet;
      until (CH = '');
      halt(0);
    end;
  halt(0);
  end;




{$F+} procedure myexit1; {$F-}
var tf:file of todaytype;
begin
  get_access_hard('player.dat',true);
    assign(pf,'player.dat');
    openattempts := 0;
    repeat
       inc(openattempts);
        {$I-}
        reset(pf);
       {$I+}
     until (openattempts >=1000) or (IOResult = 0);
    seek(pf,mynum);
    write(pf,pr);
    close(pf);
    unlock_file('player.dat');
    get_access_hard('slotto.dat',true);
    assign(tf,'slotto.dat');
    openattempts := 0;
    repeat
       inc(openattempts);
        {$I-}
        rewrite(tf);
       {$I+}
     until (openattempts >=1000) or (IOResult = 0);
    write(tf,tr);
    close(tf);
    unlock_file('slotto.dat');
  end;

procedure moreprompt;
  var ch:char;
  begin
    fwrite('`0<`2MORE`0>');
    sread_char(ch);
  end;

procedure runlotto;
var ch:char;
l,w:byte;
t:string;
c:array[1..4] of char;
matched:byte;
match:boolean;
num,magicnum:longint;
used:array[1..4] of boolean;
label thebegin;
begin
  sclrscr;
  IF (tr[mynum]) then begin
    fwriteln('  `2There appears to be an invisible shield, keeping you from');
    fwriteln('  advancing on the hill!  (Try again tomorrow!)');
    moreprompt;
    halt(0);
  end;
  fwriteln('`2  Following a path instinctively, you come to a large hill.');
  fwriteln('  It appears insurmountable, but you feel a warmth come over you,');
  fwriteln('  And a pulling force brings you to the top of the hill.');
  swriteln('');
  fwriteln('`2  At the top is an oddly-shaped box with buttons next to the');
  fwriteln('`2  numbers 1 through 9.  A plaque sits below it.');
  swriteln('');
  swriteln('');
  fwriteln('`0  "`2This Lottery is placed in Honor of Seth Able Robinson');
  fwriteln('   for his great wisdom and advice.`0"');
  fwriteln('              `0- `5Dedicated by Joseph Masters, 9/25/95');
  swriteln('');
  swriteln('');
  fwriteln('  `2This appears to be some kind of Lottery Machine...');
  IF (PR.GOLD < (10*PR.LEVEL)) then begin
    fwriteln('  `2However, you don''t seem to have the kind of money you');
    fwriteln('  need to use the machine!');
    moreprompt;
    halt(0);
  end;
  fwrite('`2  Try it out? [`5Y`2]:`% ');
  sread_char(ch);
  swriteln(UPCASE(CH));
  IF (UPCASE(CH) = 'N') then begin
    fwriteln('`2  You trudge home, unaware of what you''ve missed.');
    moreprompt;
    halt(0);
  end;
  tr[mynum] := true;
  swriteln('');
  str(10*PR.LEVEL, tempstr);
  DEC(PR.GOLD, 10*PR.LEVEL);
  fwriteln('`2  You deposit `$'+tempstr+'`2 gold into the box, and read');
  fwriteln('`2  the directions.');
  swriteln('');
  swriteln('');
  fwriteln('  `0"`2Press four numbers to come up with your code.  Then, wait');
  fwriteln('   for the machine to come up with its.  If you match one or');
  fwriteln('   more numbers, you will win some gold back!`0"');
  thebegin:
    swriteln('');
    fwrite('`2Enter Your Code:`% ');
    sread(tempstr);
    swriteln('');
    val(tempstr,l,errcode);
    IF (TEMPSTR = '') then halt(0);
    IF (LENGTH(TEMPSTR) < 4) then begin
      fwriteln('`2  Too short!');
      goto thebegin;
    end
    else if (LENGTH(TEMPSTR) > 4) then begin
      fwriteln('`2  Too long!');
      goto thebegin;
    end
    else if (errcode <> 0) then begin
      fwriteln('`2  Not a number!');
      goto thebegin;
    end
    else begin
      randomize;
      for  l := 1 to 4 do begin
        num := random(10);
        str(num,t);
        c[l] :=t[1];
      end;
      matched := 0;
      for l := 1 to 4 do used[l] := false;
      for l := 1 to 4 do begin
        match := false;
        w := 0;
        while not match and (w < 4) do begin
          inc(w);
          IF (c[l] = tempstr[w]) and not used[w] then begin
            used[w] := true;
            match := true;
            inc(matched);
          end;
        end;
      end;
      t := c[1]+c[2]+c[3]+c[4];
      fwriteln('`2Machine''s Code :`% '+t);
      swriteln('');
{      IF (MATCHED < 3) and (matched > 0) then begin
      str(matched,tempstr);
      fwriteln('`2  You only matched '+tempstr+'`2 number(s)!');
      swriteln('');
      fwriteln('`2  Try again tomorrow!');
      moreprompt;
      halt(0);
      end
      else} if (matched < 1) then begin
        fwriteln('`2  You didn''t match any numbers!');
        swriteln('');
        fwriteln('`2  Try again tomorrow!');
        moreprompt;
        halt(0);
      end
      else begin
        str(matched,tempstr);
        fwriteln('`2  You matched '+tempstr+'`2 numbers!');
        swriteln('');
        IF (MATCHED > 3) then
          fwriteln('`2  You hit the jackpot!')
        else
          fwriteln('`2  You almost hit the jackpot!');
          swriteln('');
          IF odd(pr.level) then magicnum := 10 else magicnum := 30;
          IF (pr.level = 12) then magicnum := 20;
              for num := -1 to ((pr.level) DIV 2) do
                magicnum := magicnum*10;
          IF (MATCHED < 4) THEN MAGICNUM := MAGICNUM DIV 10;
          IF (MATCHED < 3) THEN MAGICNUM := MAGICNUM DIV 10;
          IF (MATCHED < 2) THEN MAGICNUM := MAGICNUM DIV 10;
          str(magicnum,tempstr);
          fwriteln('`2  You win `$'+tempstr+' `2gold!');
          IF (pr.gold+magicnum > 0) then inc(pr.gold,magicnum);
          moreprompt;
        end;
      end;
  end;




procedure chkmaintenance;
  label next;
  var data,data2:text;
  datetest,datetest2 : string;
  l:byte;
  year, month,day,dow,npctime:word;
  tf:file of todaytype;
  begin
  IF NOT FileExists('lottime.dat') or
    not (fileexists('slotto.dat')) then begin
    assign(data2,'lottime.dat');
    rewrite(data2);
    GetDate(year,month,day,dow);
    str(year+month+day,datetest);
    writeln(data2, datetest);
    close(data2);
    goto next;
  end;
  assign(data2,'lottime.dat');
  reset(data2);
  readln(data2,datetest);
  close(data2);
  getdate(year,month,day,dow);
  str(year+month+day,datetest2);
  IF (datetest = datetest2) then begin
    exit;
  end;
  next:
  assign(data2,'lottime.dat');
    rewrite(data2);
    GetDate(year,month,day,dow);
    str(year+month+day,datetest);
    writeln(data2, datetest);
    close(data2);
  for l := 0 to 149 do tr[l] := false;
  assign(tf,'slotto.dat');
  rewrite(tf);
  write(tf,tr);
  close(tf);
end;





begin
  tempstr := paramstr(0);
  slpath:='';
  for tempnum := 1 to Length(tempstr)-11 do slpath := slpath + tempstr[tempnum];
  IF (PARAMCOUNT <> 1) then begin
    clrscr;
    writeln('IMPROPER USAGE!');
    halt;
  end;
  IF (CAPS(PARAMSTR(1)) = 'CONFIG') then configuration;
  initdoordriver('node'+paramstr(1)+'.dat');
  assign(data,'info.'+paramstr(1));
  reset(data);
  for tempnum := 1 to 14 do if not eof(data) then readln(data,elbow[tempnum]);
  close(data);
  val(paramstr(1),node_num,errcode);
  statfore := 14;
  statback := 1;
  notime := '**** TIMEOUT ****';
  progname := 'Seth''s Lotto';
  user_first_name := stripped(elbow[6]);
  ansion := true;
  SaveExit:=Exitproc;
  ExitProc:=@myexit1;
  chkmaintenance;
  readin;
  runlotto;
end.
